//+------------------------------------------------------------------+
//|                                               Bears_Bulls_MA.mq4 |
//|                                         Copyright  2008, Kharko |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008,   "

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1 Silver
#property indicator_color2 Yellow
//---- input parameters
extern int BearsBullsPeriod=13;
extern int SignalSMA=13; 
//---- buffers
double BearsBullsBuffer[];
double ISMABuffer[];
double TempBuffer[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   string short_name;
//---- 1 additional buffer used for counting.
   IndicatorBuffers(3);
   IndicatorDigits(Digits);
//---- indicator line
   SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(0,BearsBullsBuffer);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(1,ISMABuffer);
   SetIndexBuffer(2,TempBuffer);
//---- name for DataWindow and indicator subwindow label
   short_name="Bears&Bulls_MA("+BearsBullsPeriod+")";
   IndicatorShortName(short_name);
   SetIndexLabel(0,short_name);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Bears Power                                                      |
//+------------------------------------------------------------------+
int start()
  {
   int i,counted_bars=IndicatorCounted();
//----
   if(Bars<=BearsBullsPeriod) return(0);
//----
   int limit=Bars-counted_bars;
   if(counted_bars>0) limit++;
   for(i=0; i<limit; i++)
      TempBuffer[i]=iMA(NULL,0,BearsBullsPeriod,0,MODE_EMA,PRICE_CLOSE,i);
//----
   i=Bars-counted_bars-1;
   while(i>=0)
     {
      BearsBullsBuffer[i]=High[i]+Low[i]-2*TempBuffer[i];
      i--;
     }
   for(i=0; i<limit; i++)
      ISMABuffer[i]=iMAOnArray(BearsBullsBuffer,Bars,SignalSMA,0,MODE_SMA,i);  

//----
   return(0);
  }
//+------------------------------------------------------------------+